#ifndef __ARCVIEWINCLUDES_H__
#define __ARCVIEWINCLUDES_H__

#pragma warning(push)
#pragma warning(disable : 4146)
#pragma warning(disable : 4192)
#pragma warning(disable : 4278)

// Import the type libraries.
// Instead of the putting in a path, like "\Program Files\ArcGIS\COM\esriSystem.olb"
// you can use the libid instead "libid:someguid"
// Find the guid in OleView.exe, under "Type Libraries" folder.

// Also, the order sometimes matters.
// esriGeometry needs to come before esriGeoDatabase.
// If you get problems compiling, complaining about an interface in the .tlh
// file being undefined, this is probably why.

// Import ArcGISVersion.dll
#include <arcgisversion.tlh>

// Import esriSystem.olb
#import "libid:5E1F7BC3-67C5-4AEE-8EC6-C4B73AAC42ED" raw_interfaces_only raw_native_types no_namespace named_guids exclude("OLE_COLOR", "OLE_HANDLE") rename("GetObject","ESRIGetObject")

// Import esriGeometry.olb
#import "libid:C4B094C2-FF32-4FA1-ABCB-7820F8D6FB68" raw_interfaces_only raw_native_types no_namespace named_guids exclude("OLE_COLOR", "OLE_HANDLE")

// Import esriGeoDatabase.olb
#import "libid:0475BDB1-E5B2-4CA2-9127-B4B1683E70C2" raw_interfaces_only raw_native_types no_namespace named_guids

// Import esriDataSourcesGDB.olb
#import "libid:4A037613-879A-484D-AF82-0802947C627B" raw_interfaces_only, raw_native_types, no_namespace, named_guids, exclude("OLE_HANDLE", "OLE_COLOR")

// Import esriDataSourcesFile.olb
#import "libid:1CE6AC65-43F5-4529-8FC0-D7ED298E4F1A" raw_interfaces_only, raw_native_types, no_namespace, named_guids, exclude("OLE_HANDLE", "OLE_COLOR")

#pragma warning(pop)

#endif