#ifndef CEDITSQLITEDB_H
#define CEDITSQLITEDB_H
#include <atlbase.h>
#include <atlsafe.h>

class CppSQLite3DB;

class CEditSQLiteDb
{
friend class CEditSQLiteDbTester;
public:
  CEditSQLiteDb(CppSQLite3DB* a_);
  ~CEditSQLiteDb();

  int SetupNewGDB();
  int CloseGDB();

  int EditTable(CComBSTR a_TableName,
                CComSafeArray<BSTR>& a_FieldNames,
                CComSafeArray<VARIANT>& a_2DValues);
  int EditTableExistingRows(CComBSTR a_TableName,
                            CComSafeArray<BSTR>& a_FieldNames,
                            CComSafeArray<VARIANT>& a_2DValues,
                            int &a_nNumRowsEdited,
                            CComBSTR a_WhereClause = "");
  int DeleteTable(CComBSTR a_TableName);

private:
  CEditSQLiteDb(const CEditSQLiteDb&);
  const CEditSQLiteDb& operator=(const CEditSQLiteDb&);

  class impl;
  impl *m_p;
}; // 

#endif
