#ifndef DATATOSAFEARRAY_H
#define DATATOSAFEARRAY_H

#include <atlbase.h>
#include <atlsafe.h>

class Grid;

namespace DataToSafeArray
{

  template <class T>
  int  OnlyArrayU2DTemplate(const char *a_table,
                            const char *a_field,
                            int a_nData,
                            const T *a_data,
                            CComSafeArray<VARIANT> &a_vals,
                            CComSafeArray<BSTR> &a_fieldNames,
                            CComBSTR &a_tableName);
  template <class T>
  int  U2DTemplate(const char *a_table,
                   const char *a_cellField,
                   const char *a_field,
                   int a_nData,
                   int a_startCellId,
                   int a_stressPeriod,
                   int a_etsSegId,
                   const T *a_data,
                   CComSafeArray<VARIANT> &a_vals,
                   CComSafeArray<BSTR> &a_fieldNames,
                   CComBSTR &a_tableName);

  int  OnlyArrayU2DREL(const char *a_table,
                       const char *a_field,
                       int a_nData,
                       const float *a_data,
                       CComSafeArray<VARIANT> &a_vals,
                       CComSafeArray<BSTR> &a_fieldNames,
                       CComBSTR &a_tableName);
  int  OnlyArrayU2DREL(const char *a_table,
                       const char *a_field,
                       int a_nData,
                       const double *a_data,
                       CComSafeArray<VARIANT> &a_vals,
                       CComSafeArray<BSTR> &a_fieldNames,
                       CComBSTR &a_tableName);
  int  U2DREL(const char *a_table,
              const char *a_cellField,
              const char *a_field,
              int a_nData,
              int a_startCellId,
              int a_stressPeriod,
              int a_etsSegId,
              const float *a_data,
              CComSafeArray<VARIANT> &a_vals,
              CComSafeArray<BSTR> &a_fieldNames,
              CComBSTR &a_tableName);
  int  U2DREL(const char *a_table,
              const char *a_cellField,
              const char *a_field,
              int a_nData,
              int a_startCellId,
              int a_stressPeriod,
              int a_etsSegId,
              const double *a_data,
              CComSafeArray<VARIANT> &a_vals,
              CComSafeArray<BSTR> &a_fieldNames,
              CComBSTR &a_tableName);
  int  OnlyArrayU2DINT(const char *a_table,
                       const char *a_field,
                       int a_nData,
                       const int *a_data,
                       CComSafeArray<VARIANT> &a_vals,
                       CComSafeArray<BSTR> &a_fieldNames,
                       CComBSTR &a_tableName);
  int  U2DINT(const char *a_table,
              const char *a_cellField,
              const char *a_field,
              int a_nData,
              int a_startCellId,
              int a_stressPeriod,
              int a_etsSegId,
              const int *a_data,
              CComSafeArray<VARIANT> &a_vals,
              CComSafeArray<BSTR> &a_fieldNames,
              CComBSTR &a_tableName);

};

#endif
