#ifndef __EDITGDB_H__
#define __EDITGDB_H__

#include "ArcViewIncludes.h"
#include <atlbase.h>
#include <atlsafe.h>
#include <vector>
#include "StdString.h"

typedef std::vector<bool>     VEC_BOOL;
typedef std::vector<char>     VEC_CHAR;
typedef std::vector<double>   VEC_DBL;
typedef std::vector<float>    VEC_FLT;
typedef std::vector<int>      VEC_INT;
typedef std::vector<unsigned int> VEC_UINT;
typedef std::vector<short>    VEC_SHORT;
typedef std::vector<CStr>     VEC_CStr;
typedef std::vector<esriFieldType> VEC_FTYPE;
typedef std::vector<IDomainPtr> VEC_DOMAIN;

class CEditGDB
{
  public:
    CEditGDB(void);
    ~CEditGDB(void);

  protected:
    CComBSTR m_szFile;

  public:
    void    SetGDBFile (CComBSTR a_name) { m_szFile = a_name; }
    HRESULT OpenGeodatabase2 (IWorkspace **ppWorkspace);

  protected:
    HRESULT FindTable (IWorkspacePtr ipWorkspace,
                       CComBSTR a_name,
                       ITable **pTable);
    HRESULT StartEditing (IWorkspacePtr ipWorkspace);
    HRESULT StopEditing (IWorkspacePtr ipWorkspace);
    HRESULT AddValuesToTable2(ICursorPtr a_Cursor,
                              ITablePtr a_Table,
                              CComSafeArray<VARIANT> &a_values,
                              CComSafeArray<BSTR> &a_names);
    HRESULT AppendValuesToTable(IRowPtr a_Row,
                                ITablePtr a_Table,
                                CComSafeArray<VARIANT> &a_values,
                                CComSafeArray<BSTR> &a_useddnames);
    bool    TableExists (IFeatureWorkspacePtr ipFW, CComBSTR szName);

  // Editing MODFLOW Tables
  public:
    // Generic
    HRESULT EditTable(CComBSTR a_TableName,
                      CComSafeArray<BSTR> &a_FieldNames,
                      CComSafeArray<VARIANT> &a_2DValues);
    HRESULT EditTableExistingRows(CComBSTR a_TableName, 
                                  CComSafeArray<BSTR> &a_UsedFieldNames,
                                  CComSafeArray<VARIANT> &a_2DValues,
                                  int &a_nNumRowsEdited,
                                  CComBSTR a_WhereClause = "");
    HRESULT AddMissingTables();
    HRESULT DeleteTable(CComBSTR a_TableName);

};

#endif
