#ifndef GRID_H
#define GRID_H

class Grid
{
public:
  Grid() : m_i(0), m_j(0), m_k(0) {}

  static Grid &Get()
  {
    static Grid m_p;
    return m_p;
  }

  void Init (int a_i,
             int a_j,
             int a_k)
  {
    m_i = a_i; m_j = a_j; m_k = a_k;
  }

  inline int GetI() { return m_i; }
  inline int GetJ() { return m_j; }
  inline int GetK() { return m_k; }
  inline int KFromId(int a_) { return ((a_ - 1) / (m_i * m_j) + 1); }
  inline int IFromId(int a_) { return (((a_ - 1) / m_j) % m_i + 1); }
  inline int JFromId(int a_) { return ((a_ - 1) % m_j + 1); }

  inline int IdFromIJK(int a_i, int a_j, int a_k)
  {return (((a_k-1) * (m_i*m_j)) + (a_i-1)*m_j + a_j);}

private:
  Grid(const Grid &rhs);
  const Grid &operator=(const Grid &rhs);

  int m_i, m_j, m_k;
};

#endif
