#ifndef MODFLOWLINK_H
#define MODFLOWLINK_H

#define DLLEXPORT __declspec( dllexport )

extern "C"
{
  DLLEXPORT int fnCreateEmptyGDB(const char *path,
                                 const char *filename,
                                 const int *personal);
  DLLEXPORT int fnOpenExistingGDB(const char* path,
                                  const char* a_filename);
  DLLEXPORT int fnCreateEmptySQLiteDB(const char* path,
                                      const char* filename,
                                      const int*  personal);
  DLLEXPORT int fnOpenExistingSQLite(const char* path,
                                     const char* a_filename);
  DLLEXPORT int fnCloseSQLite();

  DLLEXPORT int fnCreateMissingTables(const char *filename);

  DLLEXPORT int fnWriteArrayInt(const char *filename,
                                const char *a_table,
                                const char *a_cellField,
                                const char *a_field,
                                const char *a_query,
                                int a_nData,
                                int a_startCellId,
                                int* a_stressPeriod,
                                const int *a_data);
  DLLEXPORT int fnWriteArrayFlt(const char *filename,
                                const char *a_table,
                                const char *a_cellField,
                                const char *a_field,
                                const char *a_query,
                                int a_nData,
                                int a_startCellId,
                                int* a_stressPeriod,
                                const float *a_data);
  DLLEXPORT int fnWriteArrayDbl(const char *filename,
                                const char *a_table,
                                const char *a_cellField,
                                const char *a_field,
                                const char *a_query,
                                int a_nData,
                                int a_startCellId,
                                int* a_stressPeriod,
                                const double *a_data);

  DLLEXPORT int fnWriteValInt(const char *filename,
                              const char *a_table,
                              const char *a_field,
                              int a_val);
  DLLEXPORT int fnWriteValsInt(const char *filename,
                               const char *a_table,
                               const char **a_fields,
                               const char *a_query,
                               const int *a_vals,
                               int a_nDat);

  DLLEXPORT int fnStartCacheing(const char *filename,
                                const char *a_table,
                                const char *a_query);
  DLLEXPORT int fnStartCacheing2(const char *filename,
                                 const char *a_table,
                                 const char *a_query,
                                 int a_nFields,
                                 int a_nRows);
  DLLEXPORT int fnStopCacheing();
  DLLEXPORT int fnAddDataToCacheInt(const char *a_field,
                                    int a_val);
  DLLEXPORT int fnAddDataToCacheInt2(const char *a_field,
                                     int a_val,
                                     int row);
  DLLEXPORT int fnAddDataToCacheFlt(const char *a_field,
                                    float a_val);
  DLLEXPORT int fnAddDataToCacheFlt2(const char *a_field,
                                     float a_val,
                                     int row);
  DLLEXPORT int fnAddDataToCacheDbl(const char *a_field,
                                    double a_val);
  DLLEXPORT int fnAddDataToCacheDbl2(const char *a_field,
                                     double a_val,
                                     int row);
  DLLEXPORT int fnAddDataToCacheStr(const char *a_field,
                                    const char *a_val);
  DLLEXPORT int fnAddDataToCacheStr2(const char *a_field,
                                     const char *a_val,
                                     int row);
  DLLEXPORT int fnAddAuxColToTable(const char *a_table,
                                   const char *a_colName);
  DLLEXPORT int fnDeleteAllRowsInTable(const char *a_filename,
                                       const char *a_table);



#ifdef _DEBUG
  DLLEXPORT int fnDebugAppend(const char *filename);
#endif
}
#endif