// *****************************************************************************

//#include "stdafx.h"

#include "license.h"
#include "ArcViewIncludes.h"
#include <ModflowLink.h>

#if 0
enum __declspec(uuid("06870014-a87e-48f0-81e4-41eb502e7470"))
  esriLicenseProductCode
{
  esriLicenseProductCodeEngine = 10,
  esriLicenseProductCodeEngineGeoDB = 20,
  esriLicenseProductCodeArcServer = 30,
  esriLicenseProductCodeArcView = 40,
  esriLicenseProductCodeArcEditor = 50,
  esriLicenseProductCodeArcInfo = 60
};
#endif

DLLEXPORT int CheckLicense ()
{
  IArcGISVersionPtr  ipVersion;
  IAoInitializePtr   ipLicense;
  esriLicenseStatus  eStatus;
  VARIANT_BOOL       bLoaded10;
  HRESULT            hr;
  esriLicenseProductCode prodCode;
  int _esriLicenseProductCodeArcView = 40;
  int _esriLicenseProductCodeArcEditor = 50;
  int _esriLicenseProductCodeArcInfo = 60;

  // Initialize COM
  hr = ::CoInitialize(0);

  // Create an instance of the ArcGIS 10 version checker.  If running 10, this
  // needs to be run first.
  hr = ipVersion.CreateInstance(CLSID_VersionManager);
  if (SUCCEEDED(hr))
  {
    hr = ipVersion->LoadVersion(esriArcGISDesktop, L"10.2", &bLoaded10);
    if (FAILED(hr) || (bLoaded10 == VARIANT_FALSE))
      hr = ipVersion->LoadVersion(esriArcGISDesktop, L"10.1", &bLoaded10);
    if (FAILED(hr) || (bLoaded10 == VARIANT_FALSE))
      hr = ipVersion->LoadVersion(esriArcGISDesktop, L"10.0", &bLoaded10);
  }

  // Create an instance of the ArcGIS 9 (and greater) license checker
  hr = ipLicense.CreateInstance(CLSID_AoInitialize);
  if (FAILED(hr)) {
    // We could not create an instance of the license checker.
    // This could be due to the fact that the class is not registered,
    // such as when ArcGIS 9.0 or greater is not installed.
    return 0;
  }

  // Try and check out an ArcView license
  prodCode = (esriLicenseProductCode)_esriLicenseProductCodeArcView;
  hr = ipLicense->IsProductCodeAvailable(prodCode, &eStatus);
  if (eStatus == esriLicenseAvailable)
  {
    hr = ipLicense->Initialize(prodCode, &eStatus);
    if (FAILED(hr))
      return 0;

    if (eStatus == esriLicenseAlreadyInitialized ||
        eStatus == esriLicenseCheckedOut) {
      // We either already have a license or just got one
      return 1;
    }
  }

  // If we're here, it looks like they've got ArcGIS 9 or later, but don't
  // have an ArcView license.  Try for an ArcEditor license.
  prodCode = (esriLicenseProductCode)_esriLicenseProductCodeArcEditor;
  hr = ipLicense->IsProductCodeAvailable(prodCode, &eStatus);
  if (eStatus == esriLicenseAvailable)
  {
    hr = ipLicense->Initialize(prodCode, &eStatus);
    if (FAILED(hr))
      return 0;

    if (eStatus == esriLicenseAlreadyInitialized ||
        eStatus == esriLicenseCheckedOut) {
      // We either already have a license or just got one
      return 1;
    }
  }

  // If we're here, it looks like they've got ArcGIS 9 or later, but don't
  // have an ArcView or ArcEditor license.  Try for an ArcInfo license.
  prodCode = (esriLicenseProductCode)_esriLicenseProductCodeArcInfo;
  hr = ipLicense->IsProductCodeAvailable(prodCode, &eStatus);
  if (eStatus == esriLicenseAvailable)
  {
    hr = ipLicense->Initialize(prodCode, &eStatus);
    if (FAILED(hr))
      return 0;

    if (eStatus == esriLicenseAlreadyInitialized ||
        eStatus == esriLicenseCheckedOut) {
      // We either already have a license or just got one
      return 1;
    }
  }

  // Returning this value means no license was available to check out
  return 0;
}

DLLEXPORT int ShutDown ()
{
  fnCloseSQLite();
  IAoInitializePtr   ipLicense;
  HRESULT            hr;

  // Create an instance of the ArcGIS 9 (and greater) license checker
  hr = ipLicense.CreateInstance(CLSID_AoInitialize);
  if (FAILED(hr)) {
    // We could not create an instance of the license checker.
    // This could be due to the fact that the class is not registered,
    // such as when ArcGIS 9.0 or greater is not installed.
    return 0;
  }

  // Uninitialize everything
  hr = ipLicense->Shutdown();
  if (FAILED(hr))
    return 0;

  return 1;
}