

#ifdef CXX_TEST

#include <vector>
#include <systemTests\UnitTests.t.h>
#include <systemTests\util.h>
#include <RunTest.h>

#include <ModflowLink.h>
#include <license.h>

////////////////////////////////////////////////////////////////////////////////
//// InitializeTestSuite

// *****************************************************************************
// NOTES:  Tests to see if we can grab a license ok
// *****************************************************************************
void InitializeTestSuite::testInitialize ()
{
  if (testCxx::RunAllTests() == 0)
    return;
  // Grab a license
  TS_ASSERT(CheckLicense());

  // Shut down
  TS_ASSERT(ShutDown());
}




////////////////////////////////////////////////////////////////////////////////
//// TestPackagesSuite

// *****************************************************************************
// NOTES:  Set up:  create an empty GDB in a temp directory
// *****************************************************************************
void TestPackagesSuite::setUp ()
{
  if (testCxx::RunAllTests() == 0)
    return;

  CStr szTempDir;

  // Get the temp directory
  util::GetTempDirectory(szTempDir);
  m_szFile = szTempDir;

  // Create an empty personal database
  int personal = 1;
  fnCreateEmptyGDB(m_szFile.c_str(), "unittest.mdb", &personal);

  // Set the whole path and file name together
  m_szFile += "\\unittest.mdb";
}

// *****************************************************************************
// NOTES:  Tear down:  Delete the geodatabase we were using
// *****************************************************************************
void TestPackagesSuite::tearDown ()
{
  remove(m_szFile);
}


// *****************************************************************************
// NOTES:  Tests writing to a table (not all the fields) and then going back
//         and editing the existing rows (in the fields missing before),
//         and editing existing rows off of a query filter
// *****************************************************************************
void TestPackagesSuite::testEditAndAppend()
{
#ifdef _DEBUG
  if (testCxx::RunAllTests() == 0)
    return;

  // Only do this in DEBUG, as th DLL function is only available in DEBUG
  int rval;

  rval = fnDebugAppend(m_szFile);

  TS_ASSERT(rval);
#endif
}


#endif