//------------------------------------------------------------------------------
// FILE      CopyProtect.cpp
// PURPOSE   
// COPYRIGHT Aquaveo 2011 All rights reserved.
//------------------------------------------------------------------------------
#include <private/CopyProtect.h>

#include <sstream>
#include <string>

#include <protect\guiprot.h>

extern void oppRegisterRelease();

static bool fg_usingCopyProtection = false;

//------------------------------------------------------------------------------
/// \brief Checks if passed in module is enabled
//------------------------------------------------------------------------------
void cpCheckCopyProtection (int* a_flag,
                            const char *a_mod)
{
  if (!a_flag)
    return;

  std::stringstream date;
  date << __DATE__;
  std::string smonth; 
  date >> smonth;
  int day; 
  date >> day;
  int year; 
  date >> year;
  int const month(
    !smonth.compare("Jan") ? 1 :
    !smonth.compare("Feb") ? 2 :
    !smonth.compare("Mar") ? 3 :
    !smonth.compare("Apr") ? 4 :
    !smonth.compare("May") ? 5 :
    !smonth.compare("Jun") ? 6 :
    !smonth.compare("Jul") ? 7 :
    !smonth.compare("Aug") ? 8 :
    !smonth.compare("Sep") ? 9 :
    !smonth.compare("Oct") ? 10 :
    !smonth.compare("Nov") ? 11 :
    !smonth.compare("Dec") ? 12 : 0);

  // set the number of the item that allows virtual machine passwords
  AllowPasswordModNum(32);

  std::string msg;
  *a_flag = opRegistered(PROTECT_GMS, a_mod, msg,
                         true, year, month, day);
  fg_usingCopyProtection = true;
} // cpCheckCopyProtection
//------------------------------------------------------------------------------
/// \brief Releases copy protection license
//------------------------------------------------------------------------------
void cpReleaseLicense ()
{
  if (fg_usingCopyProtection)
    oppRegisterRelease();
} // cpReleaseLicense
